# TextBox Creation

[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Drawing") 
[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms")
[void] [System.Windows.Forms.Application]::EnableVisualStyles() 

# Function to list the Hosts

function Hosts_List($vc, $user, $pass)
{
	Connect-VIserver -Server $vc -User $user -Password $pass  | Out-Null
    Get-VMHost | Out-GridView
}

# Declaring the Main Form 

$MainForm = New-Object System.Windows.Forms.Form 
$MainForm.Text = "Host List"
$MainForm.Size = New-Object System.Drawing.Size(455,265) 
$MainForm.StartPosition = "CenterScreen"

# Defining an icon
$Icon = New-Object System.Drawing.Icon ("$env:USERPROFILE\desktop\Window-1.ico") 
# Changing the default icon in the main form
$MainForm.Icon = $Icon

# Defining the "OK" Button 

$OKButton = New-Object System.Windows.Forms.Button
$OKButton.Location = New-Object System.Drawing.Size(120,185)
$OKButton.Size = New-Object System.Drawing.Size(75,23)
$OKButton.Text = "OK"
$OKButton.Add_Click({Hosts_List -vc $TextBox1.Text -user $TextBox2.Text -pass $TextBox3.Text})

# Adding the Button to the Main Form
$MainForm.Controls.Add($OKButton)

# Defining the "Cancel" Button

$CancelButton = New-Object System.Windows.Forms.Button
$CancelButton.Location = New-Object System.Drawing.Size(195,185)
$CancelButton.Size = New-Object System.Drawing.Size(75,23)
$CancelButton.Text = "Cancel"
$CancelButton.Add_Click({$MainForm.Close()})

# Adding the Button to the Main Form
$MainForm.Controls.Add($CancelButton)

# Define the First Label 

$FontBold = new-object System.Drawing.Font("Arial",8,[Drawing.FontStyle]'Bold' )

$Label1 = New-Object System.Windows.Forms.Label
$Label1.Location = New-Object System.Drawing.Size(10,20) 
$Label1.Size = New-Object System.Drawing.Size(425,20)
$Label1.Font = $fontBold
$Label1.text = "Please enter vCenter Server Name"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label1)

# Define the Second Label 
$Label2 = New-Object System.Windows.Forms.Label
$Label2.Location = New-Object System.Drawing.Size(30,47) 
$Label2.Size = New-Object System.Drawing.Size(60,20) 
$Label2.Text = "vCenter:"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label2)

# Define the Third Label 
$Label3 = New-Object System.Windows.Forms.Label
$Label3.Location = New-Object System.Drawing.Size(10,80) 
$Label3.Size = New-Object System.Drawing.Size(425,20)
$Label3.Font = $fontBold
$Label3.Text = "Please enter the User Name and Password"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label3)

# Define the Fourth Label 
$Label4 = New-Object System.Windows.Forms.Label
$Label4.Location = New-Object System.Drawing.Size(30,108) 
$Label4.Size = New-Object System.Drawing.Size(60,20) 
$Label4.Text = "User:"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label4)

# Define the Fifth Label
$Label5 = New-Object System.Windows.Forms.Label
$Label5.Location = New-Object System.Drawing.Size(30,138) 
$Label5.Size = New-Object System.Drawing.Size(60,20) 
$Label5.Text = "Password:"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label5)

# Define the First Text Box 
$TextBox1 = New-Object System.Windows.Forms.TextBox
$TextBox1.Location = New-Object System.Drawing.Size(95,45)
$TextBox1.Size = New-Object System.Drawing.Size(260,20) 

# Adding the TextBox to the Main Form 
$MainForm.Controls.Add($TextBox1)

# Define the Second Text Box 
$TextBox2 = New-Object System.Windows.Forms.TextBox
$TextBox2.Location = New-Object System.Drawing.Size(95,108)
$TextBox2.Size = New-Object System.Drawing.Size(260,20) 

# Adding the TextBox to the Main Form 
$MainForm.Controls.Add($TextBox2)

# Define the Third Text Box 
$TextBox3 = New-Object System.Windows.Forms.TextBox
$TextBox3.Location = New-Object System.Drawing.Size(95,138)
# Masking the Password Character
$TextBox3.PasswordChar = '*'
$TextBox3.Size = New-Object System.Drawing.Size(260,20) 

# Adding the TextBox to the Main Form 
$MainForm.Controls.Add($TextBox3)

# Deciding whether the form will always be at top 
$MainForm.Topmost = $False

$Handler = {$MainForm.ActiveControl = $TextBox1}

$MainForm.add_Load($Handler)
$MainForm.Add_Shown({$MainForm.Activate()})
# Showing the Main Form 
[Void] $MainForm.ShowDialog()