[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Drawing") 
[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms")
[void] [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms.TextBox")
[void] [System.Windows.Forms.Application]::EnableVisualStyles() 

# Define the Global Variables

$Global:Hosts = $NULL
$Global:HostName = $NULL
$Global:vmSelect = $false
$Global:dataSelect = $false

# Define the functions

# Getting the list of hosts

function Hosts_List($vc, $user, $pass)
{
	Connect-VIserver -Server $vc -User $user -Password $pass  | Out-Null
    Get-VMHost
    $MainForm.Close()
}

# Checking whether checkbox has been checked or not
function CheckBox-Changed($object){

    If($object.Checked ){
       Return $True
    }
}

# Declaring the Main Form 

$MainForm = New-Object System.Windows.Forms.Form 
$MainForm.Text = "Host List"
$MainForm.Size = New-Object System.Drawing.Size(455,265) 
$MainForm.StartPosition = "CenterScreen"

# Defining an icon
$Icon = New-Object System.Drawing.Icon ("$env:USERPROFILE\desktop\Window-1.ico") 
# Changing the default icon in the main form
$MainForm.Icon = $Icon

# Defining the "OK" Button 

$OKButton = New-Object System.Windows.Forms.Button
$OKButton.Location = New-Object System.Drawing.Size(120,185)
$OKButton.Size = New-Object System.Drawing.Size(75,23)
$OKButton.Text = "OK"
$OKButton.Add_Click({$Global:Hosts = Hosts_List -vc $TextBox1.Text -user $TextBox2.Text -pass $TextBox3.Text})

# Adding the Button to the Main Form
$MainForm.Controls.Add($OKButton)

# Defining the "Cancel" Button

$CancelButton = New-Object System.Windows.Forms.Button
$CancelButton.Location = New-Object System.Drawing.Size(195,185)
$CancelButton.Size = New-Object System.Drawing.Size(75,23)
$CancelButton.Text = "Cancel"
$CancelButton.Add_Click({$MainForm.Close()})

# Adding the Button to the Main Form
$MainForm.Controls.Add($CancelButton)

# Define the First Label 

$FontBold = new-object System.Drawing.Font("Arial",8,[Drawing.FontStyle]'Bold' )

$Label1 = New-Object System.Windows.Forms.Label
$Label1.Location = New-Object System.Drawing.Size(10,20) 
$Label1.Size = New-Object System.Drawing.Size(425,20)
$Label1.Font = $fontBold
$Label1.text = "Please enter vCenter Server Name"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label1)

# Define the Second Label 
$Label2 = New-Object System.Windows.Forms.Label
$Label2.Location = New-Object System.Drawing.Size(30,47) 
$Label2.Size = New-Object System.Drawing.Size(60,20) 
$Label2.Text = "vCenter:"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label2)

# Define the Third Label 
$Label3 = New-Object System.Windows.Forms.Label
$Label3.Location = New-Object System.Drawing.Size(10,80) 
$Label3.Size = New-Object System.Drawing.Size(425,20)
$Label3.Font = $fontBold
$Label3.Text = "Please enter the User Name and Password"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label3)

# Define the Fourth Label 
$Label4 = New-Object System.Windows.Forms.Label
$Label4.Location = New-Object System.Drawing.Size(30,108) 
$Label4.Size = New-Object System.Drawing.Size(60,20) 
$Label4.Text = "User:"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label4)

# Define the Fifth Label
$Label5 = New-Object System.Windows.Forms.Label
$Label5.Location = New-Object System.Drawing.Size(30,138) 
$Label5.Size = New-Object System.Drawing.Size(60,20) 
$Label5.Text = "Password:"

# Adding the Label to the Main Form 
$MainForm.Controls.Add($Label5)

# Define the First Text Box 
$TextBox1 = New-Object System.Windows.Forms.TextBox
$TextBox1.Location = New-Object System.Drawing.Size(95,45)
$TextBox1.Size = New-Object System.Drawing.Size(260,20) 

# Adding the TextBox to the Main Form 
$MainForm.Controls.Add($TextBox1)

# Define the Second Text Box 
$TextBox2 = New-Object System.Windows.Forms.TextBox
$TextBox2.Location = New-Object System.Drawing.Size(95,108)
$TextBox2.Size = New-Object System.Drawing.Size(260,20) 

# Adding the TextBox to the Main Form 
$MainForm.Controls.Add($TextBox2)

# Define the Third Text Box 
$TextBox3 = New-Object System.Windows.Forms.TextBox
$TextBox3.Location = New-Object System.Drawing.Size(95,138)
# Masking the Password Character
$TextBox3.PasswordChar = '*'
$TextBox3.Size = New-Object System.Drawing.Size(260,20) 

# Adding the TextBox to the Main Form 
$MainForm.Controls.Add($TextBox3)

# Deciding whether the form will always be at top 
$MainForm.Topmost = $False

$Handler = {$MainForm.ActiveControl = $TextBox1}

$MainForm.add_Load($Handler)
$MainForm.Add_Shown({$MainForm.Activate()})
# Showing the Main Form 
[Void] $MainForm.ShowDialog()


# List Hosts in a new List Box


$ListForm = New-Object System.Windows.Forms.Form 
$ListForm.Text = "Select a Host"
$ListForm.Size = New-Object System.Drawing.Size(300,270) 
$ListForm.StartPosition = "CenterScreen"

# Defining an icon
$Icon = New-Object System.Drawing.Icon ("$env:USERPROFILE\desktop\Window-1.ico") 
# Changing the default icon in the main form
$ListForm.Icon = $Icon

# If Enter Key is entered or Escape key is entered. 
# Run the task accordingly
$ListForm.KeyPreview = $True
$ListForm.Add_KeyDown({if ($_.KeyCode -eq "Enter") 
    { $Global:HostName = $ListBox.SelectedItem}})
$ListForm.Add_KeyDown({if ($_.KeyCode -eq "Escape") 
    {$ListForm.Close()}})

# Define OK Button and attach the event
$OKButton = New-Object System.Windows.Forms.Button
$OKButton.Location = New-Object System.Drawing.Size(25,175)
$OKButton.Size = New-Object System.Drawing.Size(75,23)
$OKButton.Text = "OK"
$OKButton.Add_Click({$Global:HostName = $ListBox.SelectedItem;$ListForm.Close() })
$ListForm.Controls.Add($OKButton)

# Define the Label
$ListLabel = New-Object System.Windows.Forms.Label
$ListLabel.Location = New-Object System.Drawing.Size(10,20) 
$ListLabel.Size = New-Object System.Drawing.Size(280,20) 
$ListLabel.Font = $fontBold
$ListLabel.Text = "Please select a Host:"
$ListForm.Controls.Add($ListLabel) 


# Create the ListBox
$ListBox = New-Object System.Windows.Forms.ListBox 
$ListBox.Location = New-Object System.Drawing.Size(10,40) 
$ListBox.Size = New-Object System.Drawing.Size(260,20) 
$ListBox.Height = 80

$ListBox.SelectionMode = [System.Windows.Forms.SelectionMode]::MultiSimple
$ListBox.Sorted = $true

# Add the contents in the List Box
$Global:Hosts  | %{[void] $ListBox.Items.Add($_.Name) }

# Add the List Box in the Form 
$ListForm.Controls.Add($ListBox) 

# Define and add the first check box 

$CheckBox1 = New-Object System.Windows.Forms.CheckBox
$CheckBox1.Location = New-Object System.Drawing.Point(10, 112)
$CheckBox1.size = New-Object System.Drawing.Size(141, 24)
$CheckBox1.Text = "VM List"
$CheckBox1.add_CheckedChanged({$Global:vmSelect = (CheckBox-Changed $CheckBox1 )})

$ListForm.Controls.Add($CheckBox1)

# Define and add the Second check box 
$CheckBox2 = New-Object System.Windows.Forms.CheckBox
$CheckBox2.Location = New-Object System.Drawing.Point(10, 140)
$CheckBox2.Size = New-Object System.Drawing.Size(141, 24)
$CheckBox2.Text = "Datastore List"
$CheckBox2.add_CheckedChanged({$Global:dataSelect = (CheckBox-Changed $CheckBox2)})

$ListForm.Controls.Add($CheckBox2)

$ListForm.Topmost = $True

# Show the Box 
$ListForm.Add_Shown({$ListForm.Activate()})
[void] $ListForm.ShowDialog()


# Showing the required informtion based on the input

# Showing both the VM and Datastore list 

if ($Global:vmSelect -and $Global:dataSelect ) {

# Defining the Main List Form 

    $DataVmForm = New-Object System.Windows.Forms.Form 
    $DataVmForm.Text = "List of VM's and Datastores"
    $DataVmForm.Size = New-Object System.Drawing.Size(300,300) 
    $DataVmForm.StartPosition = "CenterScreen"

    # Defining an icon
    $Icon = New-Object System.Drawing.Icon ("$env:USERPROFILE\desktop\Window-1.ico") 
    # Changing the default icon in the main form
    $DataVmForm.Icon = $Icon

    $OKButton = New-Object System.Windows.Forms.Button
    $OKButton.Location = New-Object System.Drawing.Size(75,230)
    $OKButton.Size = New-Object System.Drawing.Size(75,23)
    $OKButton.Text = "OK"
    $OKButton.Add_Click({$DataVmForm.Close()})
    $DataVmForm.Controls.Add($OKButton)

    $FontBold = new-object System.Drawing.Font("Arial",8,[Drawing.FontStyle]'Bold' )

# Showing label for VM listbox
    $Label1 = New-Object System.Windows.Forms.Label
    $Label1.Location = New-Object System.Drawing.Size(10,20) 
    $Label1.Size = New-Object System.Drawing.Size(425,20)
    $Label1.Font = $FontBold
    $Label1.text = "VM's List"
    $DataVmForm.Controls.Add($Label1)

# Adding the VM List Box

    $VmListBox = New-Object System.Windows.Forms.ListBox 
    $VmListBox.Location = New-Object System.Drawing.Size(10,40) 
    $VmListBox.Size = New-Object System.Drawing.Size(260,30) 
    $VmListBox.Height = 80

    Get-VMHost -Name "$Global:HostName" | Get-VM  | %{[void] $VmListBox.Items.Add($_.Name) }

    $DataVmForm.Controls.Add($VmListBox) 

# Adding label for Datastore listbox 
    $Label2 = New-Object System.Windows.Forms.Label
    $Label2.Location = New-Object System.Drawing.Size(10,120) 
    $Label2.Size = New-Object System.Drawing.Size(425,20)
    $Label2.Font = $FontBold
    $Label2.text = "Datastore List"
    $DataVmForm.Controls.Add($Label2)

# Adding the Datastore ListBox
    $DataListBox = New-Object System.Windows.Forms.ListBox 
    $DataListBox.Location = New-Object System.Drawing.Size(10,140) 
    $DataListBox.Size = New-Object System.Drawing.Size(260,60) 
    $DataListBox.Height = 80
    $DataListBox.Sorted = $true

    Get-VMHost -Name "$Global:HostName" | Get-Datastore  | %{[void] $DataListBox.Items.Add($_.Name) }


    $DataVmForm.Controls.Add($DataListBox) 

    $DataVmForm.Topmost = $True

    $DataVmForm.Add_Shown({$DataVmForm.Activate()})
    [void] $DataVmForm.ShowDialog()


}

ElseIf($Global:vmSelect){

# List VMs in another New List Box

    $VmForm = New-Object System.Windows.Forms.Form 
    $VmForm.Text = "List of VM's "
    $VmForm.Size = New-Object System.Drawing.Size(300,200) 
    $VmForm.StartPosition = "CenterScreen"

    # Defining an icon
    $Icon = New-Object System.Drawing.Icon ("$env:USERPROFILE\desktop\Window-1.ico") 
    # Changing the default icon in the main form
    $VmForm.Icon = $Icon

# Defining the OK Button 
    $OKButton = New-Object System.Windows.Forms.Button
    $OKButton.Location = New-Object System.Drawing.Size(75,120)
    $OKButton.Size = New-Object System.Drawing.Size(75,23)
    $OKButton.Text = "OK"
    $OKButton.Add_Click({$VmForm.Close()})
    $VmForm.Controls.Add($OKButton)

# Creating another List Box to Show the VM List
    $VmListBox = New-Object System.Windows.Forms.ListBox 
    $VmListBox.Location = New-Object System.Drawing.Size(10,40) 
    $VmListBox.Size = New-Object System.Drawing.Size(260,20) 
    $VmListBox.Height = 80
    $VmListBox.Sorted = $true

# Adding the contents of the List Box
    Get-VMHost -Name "$Global:HostName" | Get-VM  | %{[void] $VmListBox.Items.Add($_.Name) }

    $VmForm.Controls.Add($VmListBox) 

    $VmForm.Topmost = $True

# Showing the list box 
    $VmForm.Add_Shown({$VmForm.Activate()})
    [void] $VmForm.ShowDialog()

}
ElseIf($Global:dataSelect){

# List Datastores in another New List Box

    $DataForm = New-Object System.Windows.Forms.Form 
    $DataForm.Text = "List of Datastores "
    $DataForm.Size = New-Object System.Drawing.Size(300,200) 
    $DataForm.StartPosition = "CenterScreen"

    # Defining an icon
    $Icon = New-Object System.Drawing.Icon ("$env:USERPROFILE\desktop\Window-1.ico") 
    # Changing the default icon in the main form
    $DataForm.Icon = $Icon

# Definign the OK Button
    $OKButton = New-Object System.Windows.Forms.Button
    $OKButton.Location = New-Object System.Drawing.Size(75,120)
    $OKButton.Size = New-Object System.Drawing.Size(75,23)
    $OKButton.Text = "OK"
    $OKButton.Add_Click({$DataForm.Close()})
    $DataForm.Controls.Add($OKButton)

# Adding the Datastore List box
    $DataListBox = New-Object System.Windows.Forms.ListBox 
    $DataListBox.Location = New-Object System.Drawing.Size(10,40) 
    $DataListBox.Size = New-Object System.Drawing.Size(260,20) 
    $DataListBox.Height = 80
    $DataListBox.Sorted = $true

    Get-VMHost -Name "$Global:HostName" | Get-Datastore  | %{[void] $DataListBox.Items.Add($_.Name) }

    $DataForm.Controls.Add($DataListBox) 

    $DataForm.Topmost = $True

    $DataForm.Add_Shown({$DataForm.Activate()})
    [void] $DataForm.ShowDialog()

}
Else {

# Showing Error

    $ErrorForm = New-Object System.Windows.Forms.Form 
    $ErrorForm.Text = "Selection Error"
    $ErrorForm.Size = New-Object System.Drawing.Size(300,200) 
    $ErrorForm.StartPosition = "CenterScreen"

    # Defining an icon
    $Icon = New-Object System.Drawing.Icon ("$env:USERPROFILE\desktop\Window-1.ico") 
    # Changing the default icon in the main form
    $ErrorForm.Icon = $Icon

# Definign the OK Button
    $OKButton = New-Object System.Windows.Forms.Button
    $OKButton.Location = New-Object System.Drawing.Size(75,120)
    $OKButton.Size = New-Object System.Drawing.Size(75,23)
    $OKButton.Text = "OK"
    $OKButton.Add_Click({$ErrorForm.Close()})
    $ErrorForm.Controls.Add($OKButton)

# Showing label for VM listbox
    $Label = New-Object System.Windows.Forms.Label
    $Label.Location = New-Object System.Drawing.Size(10,20) 
    $Label.Size = New-Object System.Drawing.Size(425,20)
    $Label.Font = $fontBold
    $Label.text = "Please select Something"
    $ErrorForm.Controls.Add($Label)

    $ErrorForm.Topmost = $True

    $ErrorForm.Add_Shown({$ErrorForm.Activate()})
    [void] $ErrorForm.ShowDialog()
}
